#!/usr/bin/perl

##### 'Systemcall' script developed by the-me on irc.quakenet.org ( #Linux-Dev ) Version 6.1
##### This program is free software; you can redistribute it and/or modify
##### it under the terms of the GNU General Public License as published by
##### the Free Software Foundation; either version 2 of the License, or
##### (at your option) any later version.
##### This program is distributed in the hope that it will be useful,
##### but WITHOUT ANY WARRANTY; without even the implied warranty of
##### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##### GNU General Public License for more details.
##### You should have received a copy of the GNU General Public License
##### along with this program; if not, write to the Free Software
##### Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

### Xchat registers and hooks.

Xchat::register("irc.quakenet.org:6667 #Linux-Dev Systemcall Script for XChat", "6.1", "This is the /systemcall Perlscript for XChat on Linux", "");
Xchat::print"» Loaded Systemcall Version 6.1 successful from 'the-me' on irc.quakenet.org @ #Linux-Dev - Try /systemcall_help «";
Xchat::hook_command("systemcall", "systemcall");
Xchat::hook_command("systemcall_echo", "systemcall_echo");
Xchat::hook_command("systemcall_pub", "systemcall_pub");
Xchat::hook_command("systemcall_help", "systemcall_help");

### Important things at startup.

use warnings;
use strict;

my $xdir = Xchat::get_info('xchatdir');
&systemcall_read_conf();

### Declare the variables.

my $device;

### Main sub of this script, the whole systeminfo script.

sub systemcall {
	my($gd, $wm, $fn, $distri);
	my $wcheckgnome = `ps ax | grep gdm | head -1 | cut -d" " -f17`;
	chomp($wcheckgnome);
	if($wcheckgnome ne '/usr/sbin/gdm'){
		$wcheckgnome = `ps ax | grep gdm | head -1 | cut -d" " -f18`;
	}
	if($wcheckgnome =~ /gdm/i){
		$gd = 1;
		$wm = "Gnome: ".`gnome-panel --version | cut -d" " -f3-`."";
	}
	if(!$gd){
		my $wcheckkde = `ps ax | grep kded | head -1 | cut -d" " -f17,18,19`;
		if($wcheckkde =~ /kded/){
			$wm = "KDE: ".`kde-config --version | grep KDE | cut -d" " -f2-`."";
		}
	}
	unless(defined $wm){
		$wm = 'Windowmanager: Unknown';
	}
	for(qw(debian_version gentoo-release slackware-version redhat-release mandrake-release)){
		if(-e ($fn = "/etc/$_")){
			open FH, $fn or die $!;
			($distri = <FH>) =~ s/version //;
		}
	}
	unless(defined $distri){
		if(-e "/etc/lsb-release"){
			$distri = "Ubuntu ".`grep RELEASE /etc/lsb-release | cut -d"=" -f2`."";
		}
		elsif(-e "/etc/SuSE-release"){
			$distri = `grep SuSE /etc/SuSE-release | sed 's/version //'`;
			unless(defined $distri){
				$distri = `grep SUSE /etc/SuSE-release | sed 's/version //'`;
			}
		}
		elsif(-e "/etc/lfs-release"){
			$distri = "LFS ".`cat /etc/lfs-release`."";
		}
		elsif(-e "/etc/mandrakelinux-release"){
			$distri = `cat /etc/mandrakelinux-release | cut -d" " -f1,3`;
		}
		unless(defined $distri){
			$distri = 'Unknown';
		}
	}
	my $perlv = sprintf "%vd", $^V;
	my $xchat = Xchat::get_info('version');
	my $vgadevice = `lspci | grep VGA | cut -d" " -f5- | head -1`;
	my $sound = `lspci | grep audio | cut -d" " -f5- | head -1`;
	my $qt = `kde-config --version | grep Qt | cut -d " " -f2`;
	unless(defined $qt){
		$qt = 'N/A';
	}
	my $kernel = `uname -r`;
	my $vgahz = `xrandr | grep "*" | cut -d"*" -f3 | cut -d" " -f1`;
	system("xdpyinfo > /tmp/xdpyinfo.tmp");
	my $vgares = `grep dimensions /tmp/xdpyinfo.tmp | cut -d" " -f7`;
	my $vgabit = `grep "depth of root" /tmp/xdpyinfo.tmp | cut -d " " -f10`;
	my $xver = `grep "X.Org version" /tmp/xdpyinfo.tmp | cut -d " " -f3`;
	my $xorg = "X.Org: $xver";
	unless(defined $xver){
		$xorg = "Xfree86: ".`grep "^X" /tmp/xdpyinfo.tmp | cut -d" " -f3`."";
	}
	open(MEMINFO,"</proc/meminfo");
	my @meminfo = (<MEMINFO>);
	close(MEMINFO);
	my @total = split(/\s+/, $meminfo[0]);
	my @free = split(/\s+/, $meminfo[1]);
	my $total = join(" ", $total[1]);
	my $free = join(" ", $free[1]);
	my $ramuse = int(($total - $free) / 1024);
	my $ramtotal = int($total / 1024);
	open(CPU, "</proc/cpuinfo");
	my @CPU = (<CPU>);
	close(CPU);
	my @cpumodel = split(/\s+/, $CPU[4]);
	my @cpumhz = split(/\s+/, $CPU[6]);
	my @cpucache = split(/\s+/, $CPU[7]);
	my $cpumodel = join(" ", $cpumodel[3], $cpumodel[4], $cpumodel[5], $cpumodel[6]);
	my $cpumhz = join(" ", $cpumhz[3], 'MHz',);
	my $cpucache = join(" ", $cpucache[3], $cpucache[4]);
	if(-e '/sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies'){
		open(MINCPUFREQ, "</sys/devices/system/cpu/cpu0/cpufreq/scaling_min_freq");
		my $minfreq = (<MINCPUFREQ>);
		close(MINCPUFREQ);
		open(MAXCPUFREQ, "</sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq");
		my $maxfreq = (<MAXCPUFREQ>);
		close(MAXCPUFREQ);
		$minfreq = int($minfreq/1000);
		$maxfreq = int($maxfreq/1000);
		$cpumhz = "cur: $cpumhz min: $minfreq MHz max: $maxfreq MHz";
	}
	open(PARTITIONS, "</proc/partitions");
	my @partitions = (<PARTITIONS>);
	close(PARTITIONS);
	my $diskbits = 0;
	foreach my $partition (@partitions){
		my ($major, $minor, $blocks, $bytes, $devname) = split /\s+/ => $partition;
		unless(!defined $devname){
			if(length($devname) == 3){
				$diskbits = int($diskbits+$bytes);
			}
		}
	}
	$diskbits = int($diskbits/1024/1024);
	my $diskgb = "Diskcapacity: $diskbits GB";
	my $netdown = `/sbin/ifconfig $device | grep "RX bytes" | cut -d "(" -f2 | cut -d ")" -f1`;
	my $netup = `/sbin/ifconfig $device | grep "TX bytes" | cut -d "(" -f3 | cut -d ")" -f1`;
	chomp($distri, $netup, $netdown, $vgahz, $vgadevice, $vgabit, $vgares, $kernel, $sound, $ramuse, $qt, $wm, $xorg);
	my $infos = "Distribution: $distri Kernel: $kernel $xorg $wm Qt: $qt XChat: $xchat Perl: $perlv VGA: $vgadevice @ $vgares/$vgabit bpp/$vgahz Herz";
	my $infos2 = "Soundcard: $sound CPU: $cpumodel ($cpumhz) CPU-Cache: $cpucache RAM: $ramuse/$ramtotal MB Networkstats($device): Down: $netdown Up: $netup $diskgb";
	if($_[0] == 1){
		Xchat::print"$infos";
		Xchat::print"$infos2";
	} else {
		Xchat::command("say $infos");
		Xchat::command("say $infos2");
	}
	unlink('/tmp/xdpyinfo.tmp');
	return 1;
}

### A little set and call, if you want to show the output as an echo.

sub systemcall_echo {
	systemcall('1');
	return 1;
}

### Only advertise, but good advertise.

sub systemcall_pub {
	Xchat::command("say » Systemcall 6.1 for XChat ( Linux ) is available at http://www.linux-dev.org/ «");
	return 1;
}

### The whole systemcall help.

sub systemcall_help {
	Xchat::print <<END;
» You can use the following commands: «
» /systemcall » This will display your PC infos into the active window. «
» /systemcall_echo » This will display your PC infos only as echos, not public! «
» /systemcall_help » This will show you this help. «
» /systemcall_pub » This will show you your Systemcall version. «
» /hop » This will let you make a channelhop like in mIRC. «
END
	return 1;
}

### This sub reads out the config of systemcall.

sub systemcall_read_conf {
	open(CONFIG,"<$xdir/systemcall.conf");
	my @config = (<CONFIG>);
	close(CONFIG);
	foreach my $temp (@config){
		chomp($temp);
		my($name, $value) = split /\s+/, $temp, 2;
		if($name eq 'netdevice'){
			$device = $value;
		}
	}
	return 1;
}

#####
##### That's all, folks!
#####